/* compile.c
	P.Chongstitvatana
	19 Aug 97
	1 Sept 97
	3 Apr 2001  start project RZ
*/

#include "compile.h"

extern int DS;              /* from dcl.c  */
extern int CP;

/*---------------------------*/
extern rzaig();
/*----------------------------*/

FILE *FI, *FO, *FSRC;

expect( int tktype, char *mess )
{
  if( tok != tktype ) seterror(mess);
}

seterror( char *mess )
{
/*  printf("line %d ",line);
  switch( tok ) {
  case tkIDENTIFIER :
  case tkNUMBER :  printf("near '%s' : %s\n",tokstring,mess); break;
  default :	   printf(": %s\n",mess);
  }
*/
  printf("line %d near '%s' : %s\n",line,tokstring,mess);
  exit(-1);
}

extern char *lineat[];
extern char *inbuf;

main( int argc, char *argv[] )
{
  extern FILE *FO;
  char source[80], code[80], list[80], iasm[80];
  char name[80], *fname;
  static char tmp[] = "tmp000.bak";

  if( argc < 2 ) {
    printf("usage : compile source\n");
    exit(-1);
  }
  strcpy(source,argv[1]);
  strcpy(name,source);
  fname = strtok(name,".");
  if( fname == NULL ) fname = name;
  strcpy(code,fname);
  strcat(code,".out");
  strcpy(list,fname);
  strcat(list,".lst");
  strcpy(iasm,fname);
  strcat(iasm,".s2");

  initCharType();
  readinfile(source);
  FO = fopen(tmp,"wt");
  getC();
  pass1(); /* dcl.c */
  fclose(FO);

  readinfile(tmp);
  getC();
  pass2();  /* stmt.c */

  reName();

//  dumpSymTab();

//  FSRC = fopen(source,"rt");
  readinfile(source);
  FO = fopen(iasm,"wt");
  rzaig();
  fclose(FO);
//  fclose(FSRC);

  FO = fopen(code,"wb");
  writeHead(FO,CP,DS);
  dumpCode();
  fclose(FO);

  FO = fopen(list,"wt");
  showCode();
  fclose(FO);
}

